import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

//  Adaptation of examples of Appendix D of 
//        Weiss, Data Structures & Problem Solving using Java
public class GUI extends Applet implements 
	ActionListener,AdjustmentListener{
	// interface elements
	
    private TextField theXCoor, theYCoor;
    private GUICanvas theCanvas;
    private Scrollbar horiz,vert;
    private Choice    theShape;
    private List      theColor;
    private Checkbox  smallPic, mediumPic, largePic;
    private Checkbox  theFillBox;
    private Button    theDrawButton;
    private TextField theMessage;

    public void init( ){
        makeTheObjects( );
        doTheLayout( );
        theDrawButton.addActionListener( this );
        horiz.addAdjustmentListener(this);
        vert.addAdjustmentListener(this);
    }

           // Make all the objects
    private void makeTheObjects( ){
        theXCoor = new TextField( 5 );
        theYCoor = new TextField( 5 );

        theCanvas = new GUICanvas( theXCoor,theYCoor);
        theCanvas.setBackground( Color.white );
        theCanvas.setSize( 100, 100 );
        
        horiz = new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,100);
        vert  = new Scrollbar(Scrollbar.VERTICAL,0,1,0,100);

        theShape = new Choice( );
        theShape.add( "Circle" );
        theShape.add( "Square" );

        theColor = new List( 2, false );
        theColor.add( "red" );
        theColor.add( "blue" );
        theColor.select( 0 ); // make red default

        CheckboxGroup theSize = new CheckboxGroup( );
        smallPic = new Checkbox( "Small", theSize, false );
        mediumPic = new Checkbox( "Medium", theSize, true );
        largePic = new Checkbox( "Large", theSize, false );

        theFillBox = new Checkbox( "Fill" );
        theFillBox.setState( false );

        theDrawButton = new Button( "Draw" );

        theMessage = new TextField( 25 );
        theMessage.setEditable( false );
    }

        // Layout all the objects
    private void doTheLayout( ){
        Panel topHalf       = new Panel();
        Panel topHalfLeft   = new Panel();
        Panel topHalfRight  = new Panel ();
        Panel topHalfRight1 = new Panel ();
        Panel topHalfRight2 = new Panel ();
        Panel bottomHalf = new Panel();

            // Layout the top half
        topHalf.setLayout( new FlowLayout( ) );
        topHalfLeft.setLayout(new BorderLayout());
        topHalfLeft.add( theCanvas, "Center" );
        topHalfLeft.add( horiz, "South" );
        topHalfLeft.add( vert, "East" );
        
        topHalfRight.setLayout( new BorderLayout() );
        topHalfRight1.setLayout( new FlowLayout() );
        topHalfRight1.add( new Label( "Shape" ) );
        topHalfRight1.add( theShape );
        topHalfRight1.add( theColor );

        
        topHalfRight2.setLayout( new GridLayout(2,2) );
        topHalfRight2.add( new Label( "X coor",Label.RIGHT) );
        topHalfRight2.add( theXCoor );
        topHalfRight2.add( new Label( "Y coor" ,Label.RIGHT) );
        topHalfRight2.add( theYCoor );
        
        topHalfRight.add(topHalfRight1,"North");
        topHalfRight.add(topHalfRight2,"South");
        topHalf.add(topHalfLeft);
        topHalf.add(topHalfRight);

            // Layout the bottom half
        bottomHalf.setLayout( new FlowLayout( ) );
        bottomHalf.add( smallPic );
        bottomHalf.add( mediumPic );
        bottomHalf.add( largePic );
        bottomHalf.add( theFillBox );
        bottomHalf.add( theDrawButton );
        bottomHalf.add( theMessage );

            // Now layout GUI
        setLayout( new BorderLayout( ) );
        add( topHalf, "North" );
        add( bottomHalf, "South" );
    }

    public void actionPerformed( ActionEvent evt ){
    	// comme il n'y a que le bouton "draw" qui est cout on n'a pas 
    	//  tester la provenance
        try{
            int x,y;
            theCanvas.setParams(
                theShape.getSelectedItem( ),
                theColor.getSelectedItem( ),
                x=Integer.parseInt( theXCoor.getText( ) ),
                y=Integer.parseInt( theYCoor.getText( ) ),
                smallPic.getState( ) ? 0 :
                         mediumPic.getState( ) ? 1 : 2,
                theFillBox.getState( ) );
            theMessage.setText( "" );
            // remet  jour les scrollbars
            horiz.setValue(x);
            vert.setValue(y);
        }
        catch( Exception e ){ 
        	theMessage.setText( "Incomplete input" ); }
	}
	
    public void adjustmentValueChanged(AdjustmentEvent e){
        // reflter les changements de valeurs dans les coordonnes
        if (e.getSource()==horiz) theXCoor.setText(""+horiz.getValue());
        else theYCoor.setText(""+vert.getValue());
    }
   
}
