import java.awt.*;
import java.awt.event.*;

public class GUICanvas
    extends Canvas implements MouseListener{

    private String theShape = "";
    private String theColor = "";
    private int xcoor,ycoor;
    private int theSize;  // 0 = small, 1 = med, 2 = large
    private boolean fillOn;
    private int theWidth;
    private TextField theXCoor, theYCoor;
    
    GUICanvas (TextField theXCoor, TextField theYCoor){
    	// garder une rfrence sur les champs de textes de l'application appelante
    	this.theXCoor = theXCoor;
    	this.theYCoor = theYCoor;
    	addMouseListener(this);
    }
    
    public void setParams( String aShape, String aColor, int x,
                           int y, int size, boolean fill ){
        this.theShape = aShape;
        this.theColor = aColor;
        xcoor = x;
        ycoor = y;
        theSize = size;
        fillOn = fill;
        repaint( );
    }

    public void paint( Graphics g ){
    	g.setColor(Color.black);
    	g.drawRect(0,0,getSize().width-1,getSize().height-1);
    	
        if( theColor.equals( "red" ) )
            g.setColor( Color.red );
        else if( theColor.equals( "blue" ) )
            g.setColor( Color.blue );

        theWidth = 25 * ( theSize + 1 );

        if( theShape.equals( "Square" ) )
            if( fillOn )
                g.fillRect( xcoor, ycoor, theWidth, theWidth );
            else
                g.drawRect( xcoor, ycoor, theWidth, theWidth );
        else if( theShape.equals( "Circle" ) )
            if( fillOn )
                g.fillOval( xcoor, ycoor, theWidth, theWidth );
            else
                g.drawOval( xcoor, ycoor, theWidth, theWidth );
    }
    
    // traitement des clics de souris
    public void mouseClicked(MouseEvent event){
    }

    public void mouseReleased(MouseEvent event){
    }

    public void mousePressed(MouseEvent event){
    	// affiche les coordonnes de la souris dans les champs de texte X et Y
    	theXCoor.setText(Integer.toString(event.getX()));
    	theYCoor.setText(Integer.toString(event.getY()));
    }

    public void mouseEntered(MouseEvent event){
    }

    public void mouseExited(MouseEvent event){
    }

}
