// MODULE: Phrazibus6.java
// AUTEUR: felipe
// OBJET: interface ++ - exemple de cours
// COMMENT: interaction du bouton "nouvelle phrase"

import java.awt.*;
import java.awt.event.*;


public class Phrazibus6 extends FenetreFermante implements ActionListener {

  // -------------------------------------------------
  // Les donnees membres
  // -------------------------------------------------

  private String  Sujet[] = {"Marie", "Julie", "Linda", "Pierre","Jacques"};
  private String  Verbes[] = {"aime", "deteste", "adore"};
  private String  Cod[] = {"les pommes","Fabienne","Jean","le sucre"};

  private Panel panelSujet = new Panel();
  private Panel panelVerbes = new Panel();
  private Panel panelCod = new Panel();
  private Panel panelPhrase = new Panel();
  private Panel panelNouvelle = new Panel();

  // on a besoin de quelques references
  private Button boutons[] = new Button [50];
  private int nbBoutons = 0;
  private TextField texte; // une ref sur la phrase

  // -------------------------------------------------
  // Le constructeur
  // -------------------------------------------------
  Phrazibus6 (int l,int h, String titre) {
     super(l,h);
     setTitle(titre);

     // le Layout par defaut des Frames est un BorderLayout qui
     // ici ne convient pas (nous le verrons plus tard)

     setLayout(new FlowLayout());

     // remplissage des panels
     // note: le Layout par defaut des panels est FlowLayout

     for (int i=0; i<Sujet.length; i++) {
       boutons[nbBoutons] = new Button(Sujet[i]);
       panelSujet.add(boutons[nbBoutons]);
       boutons[nbBoutons].addActionListener(this);
       nbBoutons++;
     }

     for (int i=0; i<Verbes.length; i++) {
        panelVerbes.add(boutons[nbBoutons]=new Button(Verbes[i]));
        boutons[nbBoutons++].addActionListener(this);
     }

     for (int i=0; i<Cod.length; i++) {
        panelCod.add(boutons[nbBoutons]=new Button(Cod[i]));
        boutons[nbBoutons++].addActionListener(this);
     }

     panelPhrase.add(new Label("Phrase:"));
     panelPhrase.add(texte = new TextField(30));

     // on ne peut plus ecrire directement dans la zone de texte
     texte.setEnabled(false);

     panelNouvelle.add(boutons[nbBoutons]=new Button("Nouvelle phrase"));
     boutons[nbBoutons++].addActionListener(this);


     // il reste encore a ajouter les panels dans la fenetre
     add(panelSujet);
     add(panelVerbes);
     add(panelCod);
     add(panelPhrase);
     add(panelNouvelle);
     show();
  }

  // -------------------------------------------------------------
  // la gestion des evenements
  // -------------------------------------------------------------

  public void actionPerformed (ActionEvent evt) {
    String arg = evt.getActionCommand();

    /* Voici une premiere methode

    if (arg.equals("Nouvelle phrase")) {
      texte.setText("");
    } else
      texte.setText(texte.getText() + " " + arg);

    */

    // Celle-ci est plus propre

    Object obj = evt.getSource();
    if (obj == boutons[nbBoutons-1]) texte.setText("");
    else
      texte.setText(texte.getText() + " " + evt.getActionCommand());

  }

  // -------------------------------------------------------------
  // jeux de main, jeux de vilain
  // -------------------------------------------------------------
  public static void main(String[] args) {
    new Phrazibus6(330,230,"Phrazibus 6");
  }

}
