// MODULE: Phrazibus7.java
// AUTEUR: felipe
// OBJET: interface ++ - exemple de cours
// COMMENT: controle de l'interaction (sujet, vb , complement)

import java.awt.*;
import java.awt.event.*;


public class Phrazibus7 extends FenetreFermante implements ActionListener {

  // -------------------------------------------------
  // Les donnees membres
  // -------------------------------------------------

  private String  Sujet[] = {"Marie", "Julie", "Linda", "Pierre","Jacques"};
  private String  Verbes[] = {"aime", "deteste", "adore"};
  private String  Cod[] = {"les pommes","Fabienne","Jean","le sucre"};

  private Panel panelSujet = new Panel();
  private Panel panelVerbes = new Panel();
  private Panel panelCod = new Panel();
  private Panel panelPhrase = new Panel();
  private Panel panelNouvelle = new Panel();

  // on a besoin de quelques references
  private Button boutons[] = new Button [50];
  private int nbBoutons = 0;
  private TextField texte; // une ref sur la phrase

  // et de quelques variables d'etat
  private boolean aUnSujet,aUnVerbe;
  private int nbMots;
  private final int indiceDebutSujet,indiceDebutVerbe,indiceDebutCod,indiceFinCod;

  // -------------------------------------------------
  // Le constructeur
  // -------------------------------------------------
  Phrazibus7 (int l,int h, String titre) {
     super(l,h);
     setTitle(titre);

     initEtat();

     // le Layout par defaut des Frames est un BorderLayout qui
     // ici ne convient pas (nous le verrons plus tard)

     setLayout(new FlowLayout());

     // remplissage des panels
     // note: le Layout par defaut des panels est FlowLayout

     for (int i=indiceDebutSujet=0; i<Sujet.length; i++) {
       boutons[nbBoutons] = new Button(Sujet[i]);
       panelSujet.add(boutons[nbBoutons]);
       boutons[nbBoutons].addActionListener(this);
       nbBoutons++;
     }

     indiceDebutVerbe = nbBoutons;
     for (int i=0; i<Verbes.length; i++) {
        panelVerbes.add(boutons[nbBoutons]=new Button(Verbes[i]));
        boutons[nbBoutons++].addActionListener(this);
     }

     indiceDebutCod = nbBoutons;
     for (int i=0; i<Cod.length; i++) {
        panelCod.add(boutons[nbBoutons]=new Button(Cod[i]));
        boutons[nbBoutons++].addActionListener(this);
     }
     indiceFinCod = nbBoutons;

     panelPhrase.add(new Label("Phrase:"));
     panelPhrase.add(texte = new TextField(30));
     texte.setEnabled(false);

     panelNouvelle.add(boutons[nbBoutons]=new Button("Nouvelle phrase"));
     boutons[nbBoutons++].addActionListener(this);


     // il reste encore a ajouter les panels dans la fenetre
     add(panelSujet);
     add(panelVerbes);
     add(panelCod);
     add(panelPhrase);
     add(panelNouvelle);
     show();
  }
  // -------------------------------------------------------------
  // la gestion des evenements
  // -------------------------------------------------------------

  public void actionPerformed (ActionEvent evt) {
    String arg = evt.getActionCommand();

    Object obj = evt.getSource();
    if (obj == boutons[nbBoutons-1]) {
      texte.setText("");
      initEtat();
      }
    else
      if (nbMots < 3) {// premiere contrainte
        if (aUnSujet && aUnVerbe && estUnCod(obj)) {
          texte.setText(texte.getText() + " " + evt.getActionCommand());
          nbMots++;
          }
        else
          if (aUnSujet && (!aUnVerbe) && estUnVerbe(obj)) {
            texte.setText(texte.getText() + " " + evt.getActionCommand());
            nbMots++;
            aUnVerbe = true;
          }
          else
            if ((!aUnSujet) && estUnSujet(obj)) {
              texte.setText(texte.getText() + " " + evt.getActionCommand());
              nbMots++;
              aUnSujet = true;
            }
      }

  }

  // -------------------------------------------------------------
  // quelques predicats et methodes privees
  // -------------------------------------------------------------

  private boolean estUnSujet(Object obj) {
    for (int i = indiceDebutSujet; i<indiceDebutVerbe; i++)
       if (obj == boutons[i]) return true;
    return false;
  }

  private boolean estUnVerbe(Object obj) {
    for (int i = indiceDebutVerbe; i<indiceDebutCod; i++)
       if (obj == boutons[i]) return true;
    return false;
  }

  private boolean estUnCod(Object obj) {
    for (int i = indiceDebutCod; i<indiceFinCod; i++)
       if (obj == boutons[i]) return true;
    return false;
  }

  private void initEtat() {
    aUnSujet = aUnVerbe = false;
    nbMots = 0;
  }


  // -------------------------------------------------------------
  // jeux de main, jeux de vilain
  // -------------------------------------------------------------
  public static void main(String[] args) {
    new Phrazibus7(330,230,"Phrazibus 7");
  }

}
