// MODULE: MenuTest.java
// AUTEUR: felipe
// OBJET: appercu des menus en Java
// COMMENT: Je donne ici un exemple ou je n'herite plus la classe principale
//          de FenetreFermante. Car finalement elle ne servait qu'a cacher
//          l'enregsitrement du WindowListener (via un WindowAdapter)

import java.awt.*;
import java.awt.event.*;

public class MenuTest extends Frame implements ActionListener {

  private String couleurs [] = {
     "black","blue","cyan","darkgray","gray",
     "green","lightgray","magenta","orange",
     "pink","red","white","yellow"};

  private Color [] colors = {
     Color.black,Color.blue,Color.cyan,Color.darkGray,Color.gray,
     Color.green,Color.lightGray,Color.magenta,Color.orange,
     Color.pink,Color.red,Color.white,Color.yellow
  };

  private MenuBar mb;

  private Color getColor(String s) {
    for (int i=0; i<couleurs.length; i++)
      if (couleurs[i].equals(s)) return colors[i];
    return Color.white;
  }
  // constructeur
  public MenuTest(int l, int h, String title) {

    setTitle(title);
    setSize(l,h);

    addWindowListener(new WindowAdapter () {
        public void windowClosing (WindowEvent e) {System.exit(0);}
      }
    );

    // et une barre de menus, une ...
    mb = new MenuBar();
    MenuItem mi; // une reference de travail
    Menu comp = new Menu("Composants");
    Menu couleur = new Menu("Couleurs");

    // le sous menu Textes
    Menu texteMenu = new Menu("Textes");
    mi = new MenuItem("TextArea");
    mi.addActionListener(this);
    texteMenu.add(mi);

    mi = new MenuItem("TextField");
    mi.addActionListener(this);
    texteMenu.add(mi);

    // le sous menu Choix
    Menu choixMenu = new Menu("Choix");

    mi = new MenuItem("Choice");
    mi.addActionListener(this);
    choixMenu.add(mi);

    mi = new MenuItem("List");
    mi.addActionListener(this);
    choixMenu.add(mi);

    // le sous menu boutons
    Menu boutonMenu = new Menu("Boutons");

    mi = new MenuItem("Button");
    mi.addActionListener(this);
    boutonMenu.add(mi);

    mi = new MenuItem("CheckButon");
    mi.addActionListener(this);
    boutonMenu.add(mi);

    // un item qui n'est pas un sous menu
    mi = new MenuItem("Canevas");
    mi.addActionListener(this);

    // organisation du menu composants
    comp.add(boutonMenu);
    comp.add(texteMenu);
    comp.add(choixMenu);
    comp.addSeparator();
    comp.add(mi);

    // des items
    for (int i=0 ; i<couleurs.length; i++) {
      mi = new MenuItem(couleurs[i]);
      couleur.add(mi);
      mi.addActionListener(this);
    }

    // composition de la barre de menu
    mb.add(comp);
    mb.add(couleur);
    mb.addNotify();

    setMenuBar(mb);
    show();
  }

  // l' action appelee lorsqu'on a clique sur un item
  public void actionPerformed(ActionEvent e) {
    if (e.getSource() instanceof MenuItem) {
      MenuItem m = (MenuItem)e.getSource();

      // est-ce une couleur ?
      // on pourrait comparer le texte du menuitem avec les strings de la
      // table couleurs, mais pour illustrer quelques methodes supplementaires...

      boolean pasUneCouleur = true;
      Menu menu = mb.getMenu(1); // le menu 1 est le menu des couleurs (commence a 0)
      for (int i=0; i<menu.countItems(); i++)
        if (menu.getItem(i) == m) {
          System.out.println(m.getLabel());

          setBackground(getColor(m.getLabel()));
          pasUneCouleur = false;
          break;
        }

      // si ca n'est pas une couleur, alors on affiche le texte de l'item
      if (pasUneCouleur) {
        System.out.println(((MenuItem)e.getSource()).getLabel());
      }
     }
  }

  public static void main(String [] args) {
     new MenuTest(250,300,"La derniere interface");
  }
}