// MODULE:  CanevasTest.java
// AUTEURS: Langlais (AWT) + Lokbani (Swing)
// OBJET: montrer les canevas
//        et la gestion de la souris (une partie)

/*
  plus de canvas en Swing!!!  remplacer par un JLabel ou JPanel
  
  La Mouse:
     7 actions possibles:

     - MouseListener
     public void mousePressed(MouseEvent e) ...
     public void mouseClicked(MouseEvent e) ...
     public void mouseReleased(MouseEvent e) ...
     public void mouseEntred(MouseEvent e) ...
     public void mouseExited(MouseEvent e) ...

     - MouseMotionListener
     public void mouseDragged(MouseEvent e) ...
        bouton de la souris est press
	souris dplace
     public void mouseMoved(MouseEvent e) ...
        souris dplace
	curseur se trouve dans un composant


     implanter MouseListener signifie redfinir toutes les mthodes!!
     une solution ... utiliser MouseAdapter ...

	class MouseAdapter implements MouseListener {

	     public void mousePressed(MouseEvent e) {}
	     public void mouseClicked(MouseEvent e) {}
	     public void mouseReleased(MouseEvent e) {}
	     public void mouseEntred(MouseEvent e) {}
	     public void mouseExited(MouseEvent e) {}
	     public void mouseDragged(MouseEvent e) {}
	     public void mouseMoved(MouseEvent e) {}

	}

     class EcouteMaSouris extends MouseAdapter {
           public void mouseClicked(MouseEvent e) { bla bla bla bla}
     }

     class MaFenetre extends JFrame {
           addMouseListener(new EcouteMaSouris());
     }

     class MaFenetre extends JFrame {
           addMouseListener( new MouseAdapter {
	                         public void mouseClicked(MouseEvent e) {
		                        bla bla bla bla
		                 }
			     }
	                   );
     }

     lequel des boutons a t cliqus?
     InputEvent.BUTTON1_MASK (gauche)
     InputEvent.BUTTON2_MASK (central)
     InputEvent.BUTTON3_MASK (droite)

     MouseEvent --> getModifiers
     if (e.getModifiers() & InputEvent.BUTTON1_MASK) != 0) blablabla ...

     Graphics: pour manipuler un contexte graphique
     Pour dessiner dans un composant, il nous faut redfinir la mthode
     void paintComponent(Graphics g);

     utiliser super.paintComponent(g); elle ralise en effet le dessin du composant.
     ATTENTION: appel de cette mthode avant de dessiner votre chef d'oeuvre, sinon
     il sera perdu! (dommage, dans AWT il y a un tour de passe passe rapide pour
     viter ces tracasseries. Voir le code de Langlais. Avec Swing j'ai l'impression
     qu'il faut swinguer pour obtenir les mises  jour des dessins sans rien perdre!)

     


*/     

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

class MonPoint {
    int x,y;
    MonPoint(int x, int y) {
	this.x = x;
	this.y = y;
    }
    public void dessine (Graphics g) {
	g.setColor(Color.black);
	g.fillOval(x,y,7,7);
    }
}

class MonCanvas extends JPanel implements ActionListener {

    private Image image;
    private Vector memoire = new Vector();

    // constructeur juste pour creer l'image
    public MonCanvas() {
	image = Toolkit.getDefaultToolkit().getImage("logo.gif");

	// gestion du deplacement de la souris
	addMouseMotionListener(
			       new MouseMotionAdapter() {
				       public void mouseDragged (MouseEvent e) {
					   MonPoint mp = new MonPoint(e.getX(),e.getY());
					   Graphics g = getGraphics();
					   mp.dessine(g);
					   g.dispose();
					   memoire.addElement(mp);
				       }
				   }
			       );
    }
    

    public void paintComponent(Graphics g) {
	super.paintComponent(g); //paint background
	setBackground(Color.yellow);
	Enumeration enumere = memoire.elements();
	// On sauvegarde les anciens points dessins
	while(enumere.hasMoreElements())
	    ((MonPoint)enumere.nextElement()).dessine(g);
    }

    
    public void actionPerformed (ActionEvent e) {

	memoire.clear();
	// dans tous les cas, on efface la zone d'affichage
	// On prend la rfence sur le graphique
	Graphics g = getGraphics();
	
	g.clearRect(0,0,getWidth(),getHeight());
	
	if (e.getActionCommand().equals("logo")) {
	    g.drawImage(image,50,50,this);
	}else{
	    // Si non redfinie => appel  paintComponent
	    repaint();
	}
	// On libre la rfrence sur le graphique
	g.dispose();
    }
}

// -----------------------------------------------
// test des canvas
// -----------------------------------------------

public class CanevasTest extends JFrame {
    
    private int xValue, yValue;
    
    // le constructeur
    public CanevasTest(int l,int h, String titre) {
	setSize(l,h);
	setTitle(titre);

	JButton top = new JButton("top");
	JButton west = new JButton("logo");
	JButton east = new JButton("east");
	JButton south = new JButton("efface");
	
	final MonCanvas center = new MonCanvas();
	
	Container c = getContentPane();
	
	
	
	// que faire lorsque l'on clique sur efface ou logo
	south.addActionListener(center);
	west.addActionListener(center);

	// Un BorderLayout ... pour positionner les composants
	// dans la fentre
	
	c.add(top,BorderLayout.NORTH);
	c.add(west,BorderLayout.WEST);
	c.add(east,BorderLayout.EAST);
	c.add(south,BorderLayout.SOUTH);
	c.add(center,BorderLayout.CENTER);
	
	show();
	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	
    }

    public static void main(String [] args) {
	new CanevasTest(330,230,"Zone de dessin");
    }
}










