// MODULE: CheckBoxTest.java
// AUTEURS: Langlais (AWT) + Lokbani (SWING)
// OBJET: montrer une checkBox
//        introduire le GridLayout

/*
  un CheckBox est une case  cocher.
  permet d'effectuer un choix du type oui/non.
  un CheckBox gnre deux vnements:
   ActionEvent (dj tudie)

   ItemEvent 

   public interface ItelListener extends EventListener{
     void itemStateChanged(ItemEvent e);
   }

  On peut ragir soit:
     action de la case (le cas des vnements)
     cherchant  connatre l'tat du CheckBox
        if (uncheckbox.isSelected()) etc.
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class CheckBoxTest extends JFrame implements ItemListener {

    // quelques references et donnees primitives
    private JCheckBox bleue,rouge,vert;
    private JCheckBox jours[] = {
	new JCheckBox("lundi"),
	new JCheckBox("mardi"),
	new JCheckBox("mercredi"),
	new JCheckBox("jeudi"),
	new JCheckBox("vendredi"),
	new JCheckBox("samedi"),
	new JCheckBox("dimanche")
	    };
    boolean bleueSelectionnee, vertSelectionnee, rougeSelectionnee;
    
    // le constructeur
    public CheckBoxTest(int l,int h, String titre) {
	setSize(l,h);
	setTitle(titre);
	
	bleueSelectionnee=vertSelectionnee=rougeSelectionnee=false; // inutile mais plus propre
	
	Container c = getContentPane();
	
	// le Layout par defaut des Frames est un BorderLayout qui
	// ici ne convient pas (nous le verrons plus tard), nous avons
	// choisi un FlowLayout
	
	c.setLayout(new FlowLayout());
	
	JPanel panelCouleur = new JPanel();

	bleue = new JCheckBox("bleu");
	rouge = new JCheckBox("rouge");
	vert = new JCheckBox("vert");
	panelCouleur.add(bleue);
	panelCouleur.add(rouge);
	panelCouleur.add(vert);
	bleue.addItemListener(this);
	vert.addItemListener(this);
	rouge.addItemListener(this);

	// On utilise ici un GrdiLayout: 7 lignes 1 colonne.
	
	JPanel panelJours= new JPanel(new GridLayout(7,1));
	for (int i=0; i<jours.length; i++) {
	    jours[i].addItemListener(this);
	    panelJours.add(jours[i]);
	}
	
	c.add(panelJours);
	c.add(panelCouleur);
	show();
	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
    
    // la seule methode de l'interface ItemListener
    public void itemStateChanged(ItemEvent e) {
	Container c = getContentPane();
	if (e.getSource() == bleue) {
	    bleueSelectionnee = ! bleueSelectionnee;
	    c.setBackground(getCouleur());
	} else
	    if (e.getSource() == rouge) {
		rougeSelectionnee = ! rougeSelectionnee;
		c.setBackground(getCouleur());
	    } else
		if (e.getSource() == vert) {
		    vertSelectionnee = ! vertSelectionnee;
		    c.setBackground(getCouleur());
		} else { // il s'agit d'un jour
		    for (int i=0; i< jours.length; i++)
			if (e.getSource() == jours[i]) {
			    System.out.println(jours[i].getText());
			    break;
			}
		}
    }

    public static void main(String [] args) {
	new CheckBoxTest(330,230,"CheckBox");
    }

    // gestion du melange des couleurs
    private Color getCouleur() {
	if (bleueSelectionnee && rougeSelectionnee && vertSelectionnee) return Color.gray;
	if (bleueSelectionnee && rougeSelectionnee) return Color.magenta;
	if (bleueSelectionnee && vertSelectionnee) return Color.orange;
	if (bleueSelectionnee) return Color.blue;
	
	// no blue
	
	if (rougeSelectionnee && vertSelectionnee) return Color.yellow;
	if (rougeSelectionnee) return Color.red;
	
	if (vertSelectionnee) return Color.green;
	return Color.white;
    }
}
