// MODULE: Phrazibus6.java
// AUTEURS: Langlais (AWT) + Lokbani (Swing)
// OBJET: interface ++ - exemple de cours
// COMMENT: interaction du bouton "nouvelle phrase"

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Phrazibus6 extends JFrame implements ActionListener {

  // -------------------------------------------------
  // Les donnees membres
  // -------------------------------------------------

  String  Sujet[] = {"Marie", "Julie", "Linda", "Pierre","Jacques"};
  String  Verbes[] = {"aime", "deteste", "adore"};
  String  Cod[] = {"les pommes","Fabienne","Jean","le sucre"};

  JPanel panelSujet = new JPanel();
  JPanel panelVerbes = new JPanel();
  JPanel panelCod = new JPanel();
  JPanel panelPhrase = new JPanel();
  JPanel panelNouvelle = new JPanel();

  JButton boutons[] = new JButton [50];
  int nbBoutons = 0;

  private JTextField texte; // une ref sur la phrase

  // -------------------------------------------------
  // Le constructeur
  // -------------------------------------------------
  Phrazibus6 (int l,int h, String titre) {
     setSize(l,h);
     setTitle(titre);

     Container c = getContentPane();

     // le Layout par defaut des Frames est un BorderLayout qui
     // ici ne convient pas (nous le verrons plus tard)

     c.setLayout(new FlowLayout());

     // remplissage des panels
     // note: le Layout par defaut des panels est FlowLayout

     for (int i=0; i<Sujet.length; i++) {
       boutons[nbBoutons] = new JButton(Sujet[i]);
       panelSujet.add(boutons[nbBoutons]);
       boutons[nbBoutons].addActionListener(this);
       nbBoutons++;
     }



     for (int i=0; i<Verbes.length; i++) {
        panelVerbes.add(boutons[nbBoutons]=new JButton(Verbes[i]));
        boutons[nbBoutons++].addActionListener(this);
     }

     for (int i=0; i<Cod.length; i++) {
        panelCod.add(boutons[nbBoutons]=new JButton(Cod[i]));
        boutons[nbBoutons++].addActionListener(this);
     }


     panelPhrase.add(new JLabel("Phrase:"));
     panelPhrase.add(texte = new JTextField(30));
     // on ne peut plus ecrire directement dans la zone de texte
     texte.setEnabled(false);
     texte.setDisabledTextColor(Color.black);
   
     panelNouvelle.add(boutons[nbBoutons]=new JButton("Nouvelle phrase"));
     boutons[nbBoutons++].addActionListener(this);



     // il reste encore a ajouter les panels dans la fenetre
     c.add(panelSujet);
     c.add(panelVerbes);
     c.add(panelCod);
     c.add(panelPhrase);
     c.add(panelNouvelle);
     show();
     setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

  }

  // -------------------------------------------------------------
  // la gestion des evenements
  // -------------------------------------------------------------

  public void actionPerformed (ActionEvent evt) {
    String arg = evt.getActionCommand();

    /*
    // Voici une premiere methode

    if (arg.equals("Nouvelle phrase")) {
      texte.setText("");
    } else
      texte.setText(texte.getText() + " " + arg);
    */

    // Celle-ci est plus propre

    Object obj = evt.getSource();
    if (obj == boutons[nbBoutons-1]) texte.setText("");
    else{
	texte.setText(texte.getText() + " " + evt.getActionCommand());
    }
  }

  // -------------------------------------------------------------
  public static void main(String[] args) {
    new Phrazibus6(450,230,"Phrazibus 6");
  }

}




