// MODULE: MenuTest.java
// AUTEURS: Langlais (AWT) + Lokbani (Swing)
// OBJET: appercu des menus en Java
// COMMENT: addNotify() pose problme avec les swing  vrifier.

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class MenuTest extends JFrame implements ActionListener {

  private String couleurs [] = {
     "black","blue","cyan","darkgray","gray",
     "green","lightgray","magenta","orange",
     "pink","red","white","yellow"};

  private Color [] colors = {
     Color.black,Color.blue,Color.cyan,Color.darkGray,Color.gray,
     Color.green,Color.lightGray,Color.magenta,Color.orange,
     Color.pink,Color.red,Color.white,Color.yellow
  };

  private JMenuBar mb;

  private Color getColor(String s) {
    for (int i=0; i<couleurs.length; i++)
      if (couleurs[i].equals(s)) return colors[i];
    return Color.white;
  }
  // constructeur
  public MenuTest(int l, int h, String title) {

    setTitle(title);
    setSize(l,h);

    addWindowListener(new WindowAdapter () {
        public void windowClosing (WindowEvent e) {System.exit(0);}
      }
    );

    // et une barre de menus, une ...
    mb = new JMenuBar();
    JMenuItem mi; // une reference de travail
    JMenu comp = new JMenu("Composants");
    JMenu couleur = new JMenu("Couleurs");

    // le sous menu Textes
    JMenu texteMenu = new JMenu("Textes");
    mi = new JMenuItem("TextArea");
    mi.addActionListener(this);
    texteMenu.add(mi);

    mi = new JMenuItem("TextField");
    mi.addActionListener(this);
    texteMenu.add(mi);

    // le sous menu Choix
    JMenu choixMenu = new JMenu("Choix");

    mi = new JMenuItem("Choice");
    mi.addActionListener(this);
    choixMenu.add(mi);

    mi = new JMenuItem("List");
    mi.addActionListener(this);
    choixMenu.add(mi);

    // le sous menu boutons
    JMenu boutonMenu = new JMenu("Boutons");

    mi = new JMenuItem("Button");
    mi.addActionListener(this);
    boutonMenu.add(mi);

    mi = new JMenuItem("CheckButon");
    mi.addActionListener(this);
    boutonMenu.add(mi);

    // un item qui n'est pas un sous menu
    mi = new JMenuItem("Canevas");
    mi.addActionListener(this);

    // organisation du menu composants
    comp.add(boutonMenu);
    comp.add(texteMenu);
    comp.add(choixMenu);
    comp.addSeparator();
    comp.add(mi);

    // des items
    for (int i=0 ; i<couleurs.length; i++) {
      mi = new JMenuItem(couleurs[i]);
      couleur.add(mi);
      mi.addActionListener(this);
    }

    // composition de la barre de menu
    mb.add(comp);
    mb.add(couleur);

    setJMenuBar(mb);

    show();
  }

  // l' action appelee lorsqu'on a clique sur un item
  public void actionPerformed(ActionEvent e) {
      Container c = getContentPane();

    if (e.getSource() instanceof JMenuItem) {

      JMenuItem m = (JMenuItem)e.getSource();

      // est-ce une couleur ?
      // on pourrait comparer le texte du menuitem avec les strings de la
      // table couleurs, mais pour illustrer quelques methodes supplementaires...

      boolean pasUneCouleur = true;
      JMenu menu = mb.getMenu(1); // le menu 1 est le menu des couleurs (commence a 0)

      for (int i=0; i<menu.getItemCount(); i++)
        if (menu.getItem(i) == m) {
          System.out.println(m.getText());

          c.setBackground(getColor(m.getText()));
          pasUneCouleur = false;
          break;
        }

      // si ca n'est pas une couleur, alors on affiche le texte de l'item
      if (pasUneCouleur) {
        System.out.println(((JMenuItem)e.getSource()).getText());
      }
     }
  }

  public static void main(String [] args) {
     new MenuTest(250,300,"La derniere interface");
  }
}
