// MODULE:  RadioTest.java
// AUTEURS: Langlais (AWT) + Lokbani (Swing)
// OBJET: montrer un checkboxgroup
//        avec tjs le GridLayout pour montrer une limite


/*
  Un RadioButton est une case  cocher.
  Elle permet  l'utilisateur d'effectuer un choix de type oui/non.
  Fait partie d'un groupe de boutons dans le quel un seul bouton est
       slctionn  la fois.
  Gnre les mme vnements qu'un CheckBox
  On peut exploiter son tat  un instant donn.
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class RadioTest extends JFrame implements ItemListener {

    private String mois[] = {
	"janvier","fevrier","mars","avril","mai","juin",
	"juillet","aout","septembre","octobre","novembre","decembre"
    };
    private JCheckBox ref [] = new JCheckBox [mois.length];
    private JTextField texte = new JTextField ("no selection");
    
    // le constructeur
    public RadioTest(int l,int h, String titre) {
	setSize(l,h);
	setTitle(titre);
	
	ButtonGroup groupe = new ButtonGroup();
	Panel p = new Panel(new GridLayout(4,3));
	
	for (int i=0; i<mois.length; i++) {
	    p.add(ref[i] = new JCheckBox(mois[i],false));
	    groupe.add(ref[i]);
	    ref[i].addItemListener(this);
	}
	ref[4].setSelected(true);


	Container c = getContentPane();
	
	// le Layout par defaut des Frames est un BorderLayout qui
	// ici ne convient pas (nous le verrons plus tard)
		
	c.setLayout(new GridLayout(2,1));
	//setLayout(new FlowLayout());   // une meilleure solution ici
	
	c.add(p);
	c.add(texte);
	texte.setEnabled(false);
	texte.setDisabledTextColor(Color.black);
	show();
	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	
    }
    
    // la seule methode de l'interface ItemListener
    public void itemStateChanged(ItemEvent e) {
	for (int i=0; i<ref.length; i++)
	    if (e.getSource() == ref[i]) {
		texte.setText(mois[i]);
	    }
    }
    
    public static void main(String [] args) {
	new RadioTest(330,230,"CheckBoxGroup (Radio Button)");
    }
}




